'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

exports.default = initAppManager;

var _pathToRegexp = require('path-to-regexp');

var _pathToRegexp2 = _interopRequireDefault(_pathToRegexp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initAppManager(w, history) {
  return function () {
    (0, _createClass3.default)(AppManager, null, [{
      key: '_browserPath',
      get: function get() {
        var browserState = history.getState();
        return (browserState.hash || '').split('?')[0];
      }
    }]);

    function AppManager(config, analytics) {
      var _this = this;

      (0, _classCallCheck3.default)(this, AppManager);

      this._getManagedSlotScripts = function (appName) {
        var emptyAppSlots = (0, _keys2.default)(_this._appSlots).reduce(function (emptySlots, slotName) {
          return (0, _assign2.default)(emptySlots, (0, _defineProperty3.default)({}, _this._appSlots[slotName].name, null));
        }, {});
        var appDisplayScripts = _this._guestApps[appName].display;

        return appDisplayScripts.reduce(function (scripts, displayScriptName) {
          var guestAppScript = _this._guestAppScripts[displayScriptName];

          if (!guestAppScript.managed) {
            return scripts;
          }

          return guestAppScript.slots.reduce(function (scriptsInSlots, appScriptSlotName) {
            if (!(appScriptSlotName in scriptsInSlots) || scriptsInSlots.appScriptSlotName) {
              return scriptsInSlots;
            }

            return (0, _assign2.default)({}, scriptsInSlots, (0, _defineProperty3.default)({}, appScriptSlotName, displayScriptName));
          }, scripts);
        }, emptyAppSlots);
      };

      this._getSlotElement = function (slotName) {
        var slot = _this._appSlots[slotName];

        if (!slot) {
          _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_element.no_slot', id: slotName });
          return null;
        }

        var element = w.document.querySelector('.' + slot.elementClass);

        if (!element) {
          _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_element.no_element', id: slotName });
          return null;
        }

        return element;
      };

      this._getAppScript = function () {
        var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(appScriptName) {
          var appScriptImport, newScript;
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  if (!(_this._appScripts && _this._appScripts[appScriptName])) {
                    _context2.next = 2;
                    break;
                  }

                  return _context2.abrupt('return', _this._appScripts[appScriptName]());

                case 2:
                  appScriptImport = _this._appScriptImports[appScriptName];

                  if (!(typeof appScriptImport !== 'function')) {
                    _context2.next = 6;
                    break;
                  }

                  _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_script.not_function', id: appScriptName });
                  return _context2.abrupt('return', null);

                case 6:
                  _context2.prev = 6;
                  _context2.next = 9;
                  return appScriptImport();

                case 9:
                  newScript = _context2.sent;

                  if (newScript) {
                    _context2.next = 13;
                    break;
                  }

                  _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_script.no_file', id: appScriptName });
                  return _context2.abrupt('return', null);

                case 13:
                  if ('version' in newScript) {
                    _context2.next = 16;
                    break;
                  }

                  _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_script.invalid_script', id: appScriptName });
                  return _context2.abrupt('return', null);

                case 16:

                  _this._appScripts = (0, _assign2.default)({}, _this._appScripts, (0, _defineProperty3.default)({}, appScriptName, (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                    return _regenerator2.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            return _context.abrupt('return', newScript);

                          case 1:
                          case 'end':
                            return _context.stop();
                        }
                      }
                    }, _callee, _this);
                  }))));

                  return _context2.abrupt('return', newScript);

                case 20:
                  _context2.prev = 20;
                  _context2.t0 = _context2['catch'](6);

                  _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_script.import', id: appScriptName });
                  return _context2.abrupt('return', null);

                case 24:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, _this, [[6, 20]]);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }();

      this._getPageScripts = function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(appName) {
          var slotScripts, appScriptImportPromises;
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  slotScripts = _this._getManagedSlotScripts(appName);
                  appScriptImportPromises = (0, _keys2.default)(slotScripts).reduce(function (pageScripts, slotName) {
                    if (!(slotName in slotScripts)) {
                      _this._analytics.error({ eventTitle: _this._analytics.namespace + '.get_scripts.invalid_slot', id: appName });
                      return pageScripts;
                    }

                    var appScriptImportPromise = _promise2.default.resolve().then(function () {
                      return _this._getAppScript(slotScripts[slotName]);
                    }).then(function (appScript) {
                      return { script: appScript, slot: slotName, name: slotScripts[slotName] };
                    });

                    return pageScripts.concat(appScriptImportPromise);
                  }, []);
                  return _context3.abrupt('return', _promise2.default.all(appScriptImportPromises));

                case 3:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, _this);
        }));

        return function (_x2) {
          return _ref3.apply(this, arguments);
        };
      }();

      this._hydrateScript = function (currentAppName) {
        return function () {
          var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(appScript) {
            var slotElement, newApp, script;
            return _regenerator2.default.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    slotElement = _this._getSlotElement(appScript.slot);
                    newApp = _this._guestApps[currentAppName];

                    if (slotElement) {
                      _context4.next = 5;
                      break;
                    }

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.hydrate_page.missing_element.' + appScript.slot, id: appScript.name });
                    return _context4.abrupt('return', null);

                  case 5:
                    if (!(!appScript.script || typeof appScript.script.hydrate !== 'function')) {
                      _context4.next = 7;
                      break;
                    }

                    return _context4.abrupt('return', null);

                  case 7:
                    _context4.prev = 7;
                    script = appScript.script;

                    if (!(script.version === 2)) {
                      _context4.next = 13;
                      break;
                    }

                    _context4.next = 12;
                    return script.hydrate(slotElement, newApp);

                  case 12:
                    return _context4.abrupt('return', _context4.sent);

                  case 13:
                    _context4.next = 15;
                    return script.hydrate(slotElement, history, newApp);

                  case 15:
                    return _context4.abrupt('return', _context4.sent);

                  case 18:
                    _context4.prev = 18;
                    _context4.t0 = _context4['catch'](7);

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.hydrate_page.run_script', id: appScript.name });
                    return _context4.abrupt('return', null);

                  case 22:
                  case 'end':
                    return _context4.stop();
                }
              }
            }, _callee4, _this, [[7, 18]]);
          }));

          return function (_x3) {
            return _ref4.apply(this, arguments);
          };
        }();
      };

      this._unmountScript = function (appName) {
        return function () {
          var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(appScript) {
            var slotElement, newApp, script;
            return _regenerator2.default.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    slotElement = _this._getSlotElement(appScript.slot);
                    newApp = _this._guestApps[appName];

                    if (!(!slotElement || !appScript.script || typeof appScript.script.unmount !== 'function')) {
                      _context5.next = 5;
                      break;
                    }

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.unmount.missing', id: appScript.name });
                    return _context5.abrupt('return', null);

                  case 5:
                    _context5.prev = 5;
                    script = appScript.script;

                    if (!(script.version === 2)) {
                      _context5.next = 11;
                      break;
                    }

                    _context5.next = 10;
                    return script.unmount(slotElement, newApp);

                  case 10:
                    return _context5.abrupt('return', _context5.sent);

                  case 11:
                    _context5.next = 13;
                    return script.unmount(slotElement, history, newApp);

                  case 13:
                    return _context5.abrupt('return', _context5.sent);

                  case 16:
                    _context5.prev = 16;
                    _context5.t0 = _context5['catch'](5);

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.unmount.error', id: appScript.name });
                    return _context5.abrupt('return', null);

                  case 20:
                  case 'end':
                    return _context5.stop();
                }
              }
            }, _callee5, _this, [[5, 16]]);
          }));

          return function (_x4) {
            return _ref5.apply(this, arguments);
          };
        }();
      };

      this._mountScript = function (appName) {
        return function () {
          var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(appScript) {
            var slotElement, newApp, script;
            return _regenerator2.default.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    slotElement = _this._getSlotElement(appScript.slot);
                    newApp = _this._guestApps[appName];

                    if (!(!slotElement || !newApp || !appScript.script || typeof appScript.script.mount !== 'function')) {
                      _context6.next = 5;
                      break;
                    }

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.mount.missing', id: appScript.name });
                    return _context6.abrupt('return', null);

                  case 5:
                    _context6.prev = 5;
                    script = appScript.script;

                    if (!(script.version === 2)) {
                      _context6.next = 11;
                      break;
                    }

                    _context6.next = 10;
                    return script.mount(slotElement, newApp);

                  case 10:
                    return _context6.abrupt('return', _context6.sent);

                  case 11:
                    _context6.next = 13;
                    return script.mount(slotElement, history, newApp);

                  case 13:
                    return _context6.abrupt('return', _context6.sent);

                  case 16:
                    _context6.prev = 16;
                    _context6.t0 = _context6['catch'](5);

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.mount.error', id: appScript.name });
                    return _context6.abrupt('return', null);

                  case 20:
                  case 'end':
                    return _context6.stop();
                }
              }
            }, _callee6, _this, [[5, 16]]);
          }));

          return function (_x5) {
            return _ref6.apply(this, arguments);
          };
        }();
      };

      this._stateChangeScript = function (appName) {
        return function () {
          var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(appScript) {
            var updateApp, script;
            return _regenerator2.default.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    updateApp = _this._guestApps[appName];

                    if (!(!updateApp || !appScript.script || typeof appScript.script.onStateChange !== 'function')) {
                      _context7.next = 4;
                      break;
                    }

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.state_change.missing', id: appScript.name });
                    return _context7.abrupt('return', null);

                  case 4:
                    _context7.prev = 4;
                    script = appScript.script;

                    if (!(script.version === 2)) {
                      _context7.next = 10;
                      break;
                    }

                    _context7.next = 9;
                    return script.onStateChange(updateApp);

                  case 9:
                    return _context7.abrupt('return', _context7.sent);

                  case 10:
                    _context7.next = 12;
                    return script.onStateChange(history, updateApp);

                  case 12:
                    return _context7.abrupt('return', _context7.sent);

                  case 15:
                    _context7.prev = 15;
                    _context7.t0 = _context7['catch'](4);

                    _this._analytics.error({ eventTitle: _this._analytics.namespace + '.state_change.error', id: appScript.name });
                    return _context7.abrupt('return', null);

                  case 19:
                  case 'end':
                    return _context7.stop();
                }
              }
            }, _callee7, _this, [[4, 15]]);
          }));

          return function (_x6) {
            return _ref7.apply(this, arguments);
          };
        }();
      };

      this._hydratePage = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8() {
        var currentAppName, pageScripts, hydratePromises;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                currentAppName = _this._currentAppName;

                if (currentAppName) {
                  _context8.next = 4;
                  break;
                }

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.hydrate_page.missing_route' });
                return _context8.abrupt('return', null);

              case 4:
                _context8.prev = 4;
                _context8.next = 7;
                return _this._getPageScripts(currentAppName);

              case 7:
                pageScripts = _context8.sent;
                hydratePromises = pageScripts.map(_this._hydrateScript(currentAppName));
                _context8.next = 11;
                return _promise2.default.all(hydratePromises);

              case 11:
                return _context8.abrupt('return', _context8.sent);

              case 14:
                _context8.prev = 14;
                _context8.t0 = _context8['catch'](4);

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.hydrate_page.get_scrips', id: currentAppName });
                return _context8.abrupt('return', null);

              case 18:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, _this, [[4, 14]]);
      }));

      this._updatePage = function () {
        var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(newAppName) {
          var oldAppName, _ref10, _ref11, oldAppScripts, newAppScripts, oldAppScriptNames, newAppScriptNames, unmountPromises, mountPromises, updatePromises;

          return _regenerator2.default.wrap(function _callee9$(_context9) {
            while (1) {
              switch (_context9.prev = _context9.next) {
                case 0:
                  oldAppName = _this._currentAppName;
                  _context9.next = 3;
                  return _promise2.default.all([_this._getPageScripts(oldAppName), _this._getPageScripts(newAppName)]);

                case 3:
                  _ref10 = _context9.sent;
                  _ref11 = (0, _slicedToArray3.default)(_ref10, 2);
                  oldAppScripts = _ref11[0];
                  newAppScripts = _ref11[1];
                  oldAppScriptNames = oldAppScripts.map(function (_ref12) {
                    var name = _ref12.name;
                    return name;
                  });
                  newAppScriptNames = newAppScripts.map(function (_ref13) {
                    var name = _ref13.name;
                    return name;
                  });
                  unmountPromises = oldAppScripts.filter(function (appScript) {
                    return newAppScriptNames.indexOf(appScript.name) === -1;
                  }).map(_this._unmountScript(oldAppName));
                  mountPromises = newAppScripts.filter(function (appScript) {
                    return oldAppScriptNames.indexOf(appScript.name) === -1;
                  }).map(_this._mountScript(newAppName));
                  updatePromises = oldAppScripts.filter(function (appScript) {
                    return newAppScriptNames.indexOf(appScript.name) > -1;
                  }).map(_this._stateChangeScript(newAppName));
                  _context9.next = 14;
                  return _promise2.default.all(unmountPromises);

                case 14:
                  _context9.next = 16;
                  return _promise2.default.all(mountPromises);

                case 16:
                  _context9.next = 18;
                  return _promise2.default.all(updatePromises);

                case 18:
                  return _context9.abrupt('return', null);

                case 19:
                case 'end':
                  return _context9.stop();
              }
            }
          }, _callee9, _this);
        }));

        return function (_x7) {
          return _ref9.apply(this, arguments);
        };
      }();

      this._onStateChange = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10() {
        var newAppName;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                newAppName = _this._getAppFromPath();

                if (newAppName) {
                  _context10.next = 4;
                  break;
                }

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.update_app.app_not_found' });
                return _context10.abrupt('return', null);

              case 4:
                _context10.prev = 4;
                _context10.next = 7;
                return _this._updatePage(newAppName);

              case 7:
                _context10.next = 13;
                break;

              case 9:
                _context10.prev = 9;
                _context10.t0 = _context10['catch'](4);

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.update_app', id: newAppName });
                return _context10.abrupt('return', null);

              case 13:

                _this._currentAppName = newAppName;

                return _context10.abrupt('return', null);

              case 15:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, _this, [[4, 9]]);
      }));
      this.init = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11() {
        var browserTitle, browserPath, browserQuery, currentAppName;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                if ((0, _keys2.default)(_this._appSlots).every(function (slotName) {
                  return _this._getSlotElement(slotName);
                })) {
                  _context11.next = 3;
                  break;
                }

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.init.missing_elements' });
                return _context11.abrupt('return', null);

              case 3:
                if (w.document) {
                  _context11.next = 6;
                  break;
                }

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.init.no_window' });
                return _context11.abrupt('return', null);

              case 6:
                browserTitle = w.document.title;
                browserPath = w.document.location.pathname;
                browserQuery = w.document.location.search;


                history.replaceState({}, browserTitle, '' + browserPath + browserQuery);

                currentAppName = _this._getAppFromPath();

                if (currentAppName) {
                  _context11.next = 14;
                  break;
                }

                _this._analytics.error({ eventTitle: _this._analytics.namespace + '.init_app.no_route' });
                return _context11.abrupt('return', null);

              case 14:

                _this._currentAppName = currentAppName;

                _context11.next = 17;
                return _this._hydratePage();

              case 17:

                history.Adapter.bind(w, 'statechange', _this._onStateChange);

                return _context11.abrupt('return', null);

              case 19:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, _this);
      }));

      if (!config) {
        throw new Error('Config not specified. Aborting.');
      }

      var appScriptImports = config.appScriptImports,
          guestApps = config.guestApps,
          appSlots = config.appSlots,
          guestAppScripts = config.guestAppScripts;


      this._analytics = analytics || {
        error: function error(mock) {
          return mock;
        },
        namespace: 'mock' };
      this._appScriptImports = appScriptImports;
      this._guestApps = guestApps;
      this._appSlots = appSlots;
      this._guestAppScripts = guestAppScripts;

      this._pathCheckers = (0, _keys2.default)(guestApps || {}).reduce(function (apps, appName) {
        var appPath = guestApps[appName].appPath;


        if (!appPath || typeof appPath !== 'string') {
          return apps;
        }

        return (0, _assign2.default)({}, apps, (0, _defineProperty3.default)({}, appName, (0, _pathToRegexp2.default)(appPath)));
      }, {});
    }

    (0, _createClass3.default)(AppManager, [{
      key: '_getAppFromPath',
      value: function _getAppFromPath() {
        var _this2 = this;

        var path = AppManager._browserPath;

        if (!path || typeof path !== 'string') {
          this._analytics.error({ eventTitle: this._analytics.namespace + '.get_app_from_path.no_path' });
          return null;
        }

        return (0, _keys2.default)(this._pathCheckers).find(function (appName) {
          var pathChecker = _this2._pathCheckers[appName];

          if (!pathChecker) {
            _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_app_from_path.invalid_appPath', id: appName });
            return false;
          }

          return pathChecker.exec(path);
        });
      }
    }]);
    return AppManager;
  }();
}